Index: palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90
===================================================================
--- palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90	(revision 4671)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! Introduction of wall_flags_total_0, which currently sets bits based on static
 ! topography information used in wall_flags_static_0
@@ -681,6 +684,6 @@
 !--       type, if required 
           IF ( surf_def_h(0)%ns >= 1 )  surf_def_h(0)%shf(:) = dum_surf_flux
-          IF ( surf_lsm_h%ns    >= 1 )  surf_lsm_h%shf(:)    = dum_surf_flux
-          IF ( surf_usm_h%ns    >= 1 )  surf_usm_h%shf(:)    = dum_surf_flux
+          IF ( surf_lsm_h(0)%ns >= 1 )  surf_lsm_h(0)%shf(:) = dum_surf_flux
+          IF ( surf_usm_h(0)%ns >= 1 )  surf_usm_h(0)%shf(:) = dum_surf_flux
 
           pt_surface    = pt_surf(nt) + fac * ( pt_surf(nt+1) - pt_surf(nt) )
@@ -702,6 +705,6 @@
 !--       type, if required 
           IF ( surf_def_h(0)%ns >= 1 )  surf_def_h(0)%qsws(:) = dum_surf_flux
-          IF ( surf_lsm_h%ns    >= 1 )  surf_lsm_h%qsws(:)    = dum_surf_flux
-          IF ( surf_usm_h%ns    >= 1 )  surf_usm_h%qsws(:)    = dum_surf_flux
+          IF ( surf_lsm_h(0)%ns >= 1 )  surf_lsm_h(0)%qsws(:) = dum_surf_flux
+          IF ( surf_usm_h(0)%ns >= 1 )  surf_usm_h(0)%qsws(:) = dum_surf_flux
 
        ENDIF
Index: palm/trunk/SOURCE/ocean_mod.f90
===================================================================
--- palm/trunk/SOURCE/ocean_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/ocean_mod.f90	(revision 4671)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+! 
+! 4535 2020-05-15 12:07:23Z raasch
 ! bugfix for restart data format query
 ! 
@@ -1683,5 +1686,6 @@
                          surf_def_h(0)%sasws, surf_def_h(1)%sasws,             &
                          surf_def_h(2)%sasws,                                  &
-                         surf_lsm_h%sasws,    surf_usm_h%sasws,                &
+                         surf_lsm_h(0)%sasws, surf_lsm_h(1)%sasws,             &
+                         surf_usm_h(0)%sasws, surf_usm_h(1)%sasws,             &
                          surf_def_v(0)%sasws, surf_def_v(1)%sasws,             &
                          surf_def_v(2)%sasws, surf_def_v(3)%sasws,             &
@@ -1833,5 +1837,6 @@
                          surf_def_h(0)%sasws, surf_def_h(1)%sasws,             &
                          surf_def_h(2)%sasws,                                  &
-                         surf_lsm_h%sasws,    surf_usm_h%sasws,                &
+                         surf_lsm_h(0)%sasws, surf_lsm_h(1)%sasws,             &
+                         surf_usm_h(0)%sasws, surf_usm_h(1)%sasws,             &
                          surf_def_v(0)%sasws, surf_def_v(1)%sasws,             &
                          surf_def_v(2)%sasws, surf_def_v(3)%sasws,             &
Index: palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4671)
@@ -22,9 +22,12 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+! 
+! 4535 2020-05-15 12:07:23Z raasch
 ! bugfix for restart data format query
 ! 
@@ -1442,17 +1445,17 @@
 !
 !--       Natural surfaces
-          DO  m = 1, surf_lsm_h%ns
-             i = surf_lsm_h%i(m)
-             j = surf_lsm_h%j(m)
+          DO  m = 1, surf_lsm_h(0)%ns
+             i = surf_lsm_h(0)%i(m)
+             j = surf_lsm_h(0)%j(m)
              IF ( cum_lai_hf(0,j,i) /= 0.0_wp )                                &
-                surf_lsm_h%shf(m) = cthf * exp( -ext_coef * cum_lai_hf(0,j,i) )
+                surf_lsm_h(0)%shf(m) = cthf * exp( -ext_coef * cum_lai_hf(0,j,i) )
           ENDDO
 !
 !--       Urban surfaces
-          DO  m = 1, surf_usm_h%ns
-             i = surf_usm_h%i(m)
-             j = surf_usm_h%j(m)
+          DO  m = 1, surf_usm_h(0)%ns
+             i = surf_usm_h(0)%i(m)
+             j = surf_usm_h(0)%j(m)
              IF ( cum_lai_hf(0,j,i) /= 0.0_wp )                                &
-                surf_usm_h%shf(m) = cthf * exp( -ext_coef * cum_lai_hf(0,j,i) )
+                surf_usm_h(0)%shf(m) = cthf * exp( -ext_coef * cum_lai_hf(0,j,i) )
           ENDDO
 !
Index: palm/trunk/SOURCE/poisfft_mod.f90
===================================================================
--- palm/trunk/SOURCE/poisfft_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/poisfft_mod.f90	(revision 4671)
@@ -25,6 +25,8 @@
 ! -----------------
 ! $Id$
+! OMP bugfix
+!
+! 4649 2020-08-25 12:11:17Z raasch
 ! File re-formatted to follow the PALM coding standard
-!
 !
 ! 4429 2020-02-27 15:24:30Z raasch
@@ -985,5 +987,5 @@
     INTEGER(iwp) ::  m                   !<
     INTEGER(iwp) ::  n                   !<
-!   INTEGER(iwp) ::  omp_get_thread_num  !<
+!$  INTEGER(iwp) ::  omp_get_thread_num  !<
     INTEGER(iwp) ::  tn                  !<
 
Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 4670)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 4671)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+!
+! 4649 2020-08-25 12:11:17Z raasch
 ! File re-formatted to follow the PALM coding standard
 !
@@ -650,9 +653,10 @@
              ENDIF
              CALL diffusion_s( i, j, pt, surf_def_h(0)%shf, surf_def_h(1)%shf, surf_def_h(2)%shf,  &
-                               surf_lsm_h%shf, surf_usm_h%shf, surf_def_v(0)%shf,                  &
-                               surf_def_v(1)%shf, surf_def_v(2)%shf, surf_def_v(3)%shf,            &
-                               surf_lsm_v(0)%shf, surf_lsm_v(1)%shf, surf_lsm_v(2)%shf,            &
-                               surf_lsm_v(3)%shf, surf_usm_v(0)%shf, surf_usm_v(1)%shf,            &
-                               surf_usm_v(2)%shf, surf_usm_v(3)%shf )
+                               surf_lsm_h(0)%shf, surf_lsm_h(1)%shf,                               &
+                               surf_usm_h(0)%shf, surf_usm_h(1)%shf,                               &
+                               surf_def_v(0)%shf, surf_def_v(1)%shf, surf_def_v(2)%shf,            &
+                               surf_def_v(3)%shf, surf_lsm_v(0)%shf, surf_lsm_v(1)%shf,            &
+                               surf_lsm_v(2)%shf, surf_lsm_v(3)%shf, surf_usm_v(0)%shf,            &
+                               surf_usm_v(1)%shf, surf_usm_v(2)%shf, surf_usm_v(3)%shf )
 
 !
@@ -736,5 +740,6 @@
              ENDIF
              CALL diffusion_s( i, j, q, surf_def_h(0)%qsws, surf_def_h(1)%qsws,                    &
-                               surf_def_h(2)%qsws, surf_lsm_h%qsws, surf_usm_h%qsws,               &
+                               surf_def_h(2)%qsws, surf_lsm_h(0)%qsws, surf_lsm_h(1)%qsws,         &
+                               surf_usm_h(0)%qsws, surf_usm_h(1)%qsws,                             &
                                surf_def_v(0)%qsws, surf_def_v(1)%qsws, surf_def_v(2)%qsws,         &
                                surf_def_v(3)%qsws, surf_lsm_v(0)%qsws, surf_lsm_v(1)%qsws,         &
@@ -815,5 +820,6 @@
              ENDIF
              CALL diffusion_s( i, j, s, surf_def_h(0)%ssws, surf_def_h(1)%ssws,                    &
-                               surf_def_h(2)%ssws, surf_lsm_h%ssws, surf_usm_h%ssws,               &
+                               surf_def_h(2)%ssws, surf_lsm_h(0)%ssws, surf_lsm_h(1)%ssws,         &
+                               surf_usm_h(0)%ssws, surf_usm_h(1)%ssws,                             &
                                surf_def_v(0)%ssws, surf_def_v(1)%ssws, surf_def_v(2)%ssws,         &
                                surf_def_v(3)%ssws, surf_lsm_v(0)%ssws, surf_lsm_v(1)%ssws,         &
@@ -1245,5 +1251,6 @@
 
        CALL diffusion_s( pt, surf_def_h(0)%shf, surf_def_h(1)%shf, surf_def_h(2)%shf,              &
-                         surf_lsm_h%shf, surf_usm_h%shf, surf_def_v(0)%shf, surf_def_v(1)%shf,     &
+                         surf_lsm_h(0)%shf, surf_lsm_h(1)%shf, surf_usm_h(0)%shf,                  &
+                         surf_usm_h(1)%shf, surf_def_v(0)%shf, surf_def_v(1)%shf,                  &
                          surf_def_v(2)%shf, surf_def_v(3)%shf, surf_lsm_v(0)%shf,                  &
                          surf_lsm_v(1)%shf, surf_lsm_v(2)%shf, surf_lsm_v(3)%shf,                  &
@@ -1375,5 +1382,6 @@
 
        CALL diffusion_s( q, surf_def_h(0)%qsws, surf_def_h(1)%qsws, surf_def_h(2)%qsws,            &
-                         surf_lsm_h%qsws, surf_usm_h%qsws, surf_def_v(0)%qsws, surf_def_v(1)%qsws, &
+                         surf_lsm_h(0)%qsws, surf_lsm_h(1)%qsws, surf_usm_h(0)%qsws,               &
+                         surf_usm_h(0)%qsws, surf_def_v(0)%qsws, surf_def_v(1)%qsws,               &
                          surf_def_v(2)%qsws, surf_def_v(3)%qsws, surf_lsm_v(0)%qsws,               &
                          surf_lsm_v(1)%qsws, surf_lsm_v(2)%qsws, surf_lsm_v(3)%qsws,               &
@@ -1486,5 +1494,6 @@
 
        CALL diffusion_s( s, surf_def_h(0)%ssws, surf_def_h(1)%ssws, surf_def_h(2)%ssws,            &
-                         surf_lsm_h%ssws, surf_usm_h%ssws, surf_def_v(0)%ssws, surf_def_v(1)%ssws, &
+                         surf_lsm_h(0)%ssws, surf_lsm_h(1)%ssws, surf_usm_h(0)%ssws,               &
+                         surf_usm_h(1)%ssws, surf_def_v(0)%ssws, surf_def_v(1)%ssws,               &
                          surf_def_v(2)%ssws, surf_def_v(3)%ssws, surf_lsm_v(0)%ssws,               &
                          surf_lsm_v(1)%ssws, surf_lsm_v(2)%ssws, surf_lsm_v(3)%ssws,               &
